<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070626;14051800">
	<META NAME="CHANGED" CONTENT="20070710;13185500">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Convert Right-Linear
Grammar to FA</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#how to"><U>How
to Convert Right-Linear Grammar to Finite Automaton (FA)</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">A right-linear grammar is a special
type of regular grammar, in which all productions of G must have
at most one variable in the right-hand side, and this variable must
be to the right of any terminals. 
</P>
<P STYLE="margin-bottom: 0in">Using JFLAP, we will show how to
convert a right-linear grammar to a finite automaton.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Convert Right-Linear Grammar to Finite Automaton (FA)</H2>
<P><A NAME="language1"></A>We will begin by loading the grammar. You
can either enter the grammar (shown below) or load the file
<A HREF="regGrammarToNFA.jff">regGrammarToNFA.jff</A>. 
</P>
<P><BR><BR>
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/grammarwindow.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P STYLE="margin-bottom: 0in">Now click on <B>Convert </B>and then
C<B>onvert Right-Linear Grammar to FA</B>. Your window should look
like this after entering Convert to FA mode. Each variable from the
grammar is shown as a label for a state, with the start variable the
label for the start state. In addition, there is one final state not
associated with a variable.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/convertToFA.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=647 HEIGHT=517 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, we need to add
transitions to finish the FA. When we expand the production “S-&gt;aB”,
it is similar to reading “a” in state S and moving to state B.
Thus, we should create a transition from state S to state B with the
transition “a”. After we create that transition on JFLAP, your
window should look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium"><B>*NOTE</B>
: For a tutorial on how to use the FA panel, you should first read
the tutorial pages on finite automata.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=647 HEIGHT=517 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">For productions that have no
variable on the right-side, a transition is created that goes to the
final state. You can check how many transitions you need to add by
clicking the <B>Done?</B> button. Finish entering the transitions.
JFLAP will notify you which productions are successfully created in
the FA. You can also let JFLAP automatically fill in the transitions
by clicking the <B>Show All</B> button. When you finish entering all
the transitions into FA, your window should look like :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=630 HEIGHT=505 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium"><B>*NOTE
</B>: We moved the states in the FA to produce a better picture.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">Now,
since all the transitions are added, we have successfully transformed
right-linear grammar to finite automaton. You can export this FA.
When you export the converted FA, the new <B>Finite Automaton </B>window
will pop up with the created FA states and transitions. After
exporting the FA, your <B>Finite Automaton</B> window would look like
this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=545 HEIGHT=550 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Converting Right-Linear Grammar to FA. Thanks for
reading!</B></P>
</BODY>
</HTML>
